(*
    ===========================================================================

    ---------------------------------------------------------------------------
    Gen's LowTech : bZ[WtbNg
    http://www2.biglobe.ne.jp/~sakai/usehook.htm
    http://www2.biglobe.ne.jp/~sakai/bin/list2.txt

    ---------------------------------------------------------------------------
    Using Hooks
    ms-help://MS.PSDK.1033/winui/winui/windowsuserinterface/windowing/hooks/usinghooks.htm

    ===========================================================================
*)


unit HookMain;

interface

uses
    Windows, Messages, iFMO;

(*
    ===========================================================================
    export
    ===========================================================================
*)

//  tbNCXg[
function    HookInstall(Wnd: HWND): Boolean; export; stdcall;

//  tbNACXg[
procedure   HookUnInstall(); export; stdcall;

//  
function    HookInitialize(): Boolean; export; stdcall;

//  n
procedure   HookFinalize(); export; stdcall;

const
    //  ʒmpEBhEbZ[W(DLL to EXE)
    UM_DESTROYWND  = WM_APP + 1001; //  CBTProc(in DLL)
    UM_LMOUSEUP    = WM_APP + 1002; //  MouseProc(in DLL)
    UM_RMOUSEUP    = WM_APP + 1003; //  MouseProc(in DLL)

implementation

(*
    ===========================================================================
    type
    ===========================================================================
*)

const
    //  MMF̃t@C
    FMO_NAME = '{1E2506E8-1E6D-45E1-B910-C96362648E40}';

//  L̓eɂ\
type
    PShareHookInfo = ^TShareHookInfo;
    TShareHookInfo = packed record
        HostWindow : HWND;     //  ʒmEBhE
        HCbtHook   : HHOOK;    //  tbÑnh
        HMouseHook : HHOOK;    //  tbÑnh
    end;

//  tbN֐^
type
    THookProc = function(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;

//  LłȂeɂ\
type
    PLocalHookInfo = ^TLocalHookInfo;
    TLocalHookInfo = record
        CbtHooked  : Boolean;   //  tbNtO
        MouseHooked: Boolean;   //  tbNtO
        FmoHandle: THandle;     //  FMOnh
    end;

var
    //  tbN֐̃CXg[Ɋւێ
    LHI: TLocalHookInfo;

(*
    ===========================================================================
    CBTProc
    ===========================================================================
*)
function    CBTProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;
    DestroyWnd : integer;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        //  ɂEBhE
        HCBT_DESTROYWND:
            begin
                //  jEBhẼnh
                DestroyWnd := wParam;
                PostMessage(Shi^.HostWindow, UM_DESTROYWND, DestroyWnd, 0);
            end;

        else
            ;
        end;
    end;

    //  ̐l[
    Result := CallNextHookEx(Shi^.HCbtHook, nCode, wParam, lParam);

    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    MouseProc
    ===========================================================================
*)
function    MouseProc(nCode: Integer; wParam: WPARAM; lParam: LPARAM): LRESULT; stdcall;
var
    hFMO: THandle;
    p   : Pointer;
    Shi : PShareHookInfo;
    MHS: PMouseHookStruct;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //  ǂȃbZ[Wȁ[
    if not (nCode < 0) then
    begin
        case nCode of

        //  }EXANV
        HC_ACTION:
            begin
                MHS := PMouseHookStruct(lParam);
                if (wParam = WM_LBUTTONUP) then
                    PostMessage(Shi^.HostWindow, UM_LMOUSEUP, MHS^.hwnd, 0)
                else
                if (wParam = WM_RBUTTONUP) then
                    PostMessage(Shi^.HostWindow, UM_RMOUSEUP, MHS^.hwnd, 0)
                ;
            end;

        else
            ;
        end;
    end;
    //  ̐l[
    Result := CallNextHookEx(Shi^.HMouseHook, nCode, wParam, lParam);
    //MMF}bsOAMMFnhN[Y
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    tbNCXg[
    ===========================================================================
*)
function    HookInstall(Wnd: HWND): Boolean;
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏(邢͎擾)
    Shi := PShareHookInfo(p);
    try
        //  ʒmL^
        Shi^.HostWindow := Wnd;
        //  tbN֐̓o^-1
        Shi^.HCbtHook := SetWindowsHookEx(WH_CBT, CBTProc, HInstance, 0);
        //  tbN-1
        LHI.CbtHooked := (Shi^.HCbtHook > 0);
        //  tbN֐̓o^-2
        Shi^.HMouseHook := SetWindowsHookEx(WH_MOUSE, MouseProc, HInstance, 0);
        //  tbN-1
        LHI.MouseHooked := (Shi^.HMouseHook > 0);
    finally
        //  MMFgpI
        ReleaseFileMappingObject(hFMO, p);
    end;
    //  ?
    Result := LHI.CbtHooked and LHI.MouseHooked;
end;

(*
    ===========================================================================
    tbNACXg[
    ===========================================================================
*)
procedure   HookUnInstall();
var
    hFMO: THandle;
    p: Pointer;
    Shi: PShareHookInfo;
begin
    //  MMFgp
    GetFileMappingObject(hFMO, p, FMO_NAME);
    //  tbN\̏
    Shi := PShareHookInfo(p);
    //  tbN-1
    if LHI.CbtHooked then
    begin
        UnhookWindowsHookEx(Shi^.HCbtHook);
    end;
    //  tbN-2
    if LHI.MouseHooked then
    begin
        UnhookWindowsHookEx(Shi^.HMouseHook);
    end;
    //  MMFgpI
    ReleaseFileMappingObject(hFMO, p);
end;

(*
    ===========================================================================
    
    ===========================================================================
*)
function    HookInitialize(): Boolean;
begin
    //  MMF 쐬
    FillChar(LHI, SizeOf(LHI), #0);
    LHI.FmoHandle := CreateFileMappingObject(SizeOf(TShareHookInfo), FMO_NAME);
    Result := (LHI.FmoHandle <> 0);
end;

(*
    ===========================================================================
    n
    ===========================================================================
*)
procedure   HookFinalize();
begin
    //  MMF 
    DestroyFileMappingObject(LHI.FmoHandle);
end;

end.

